--by waywardson
--sonic the hedgehog
---COLORS-----
math.randomseed(os.time())
white = Color.new(255,255,255)
red = Color.new(255,0,0)
yellow = Color.new(255,255,0)
lightblue = Color.new(100,100,255)
shadow = Color.new(0,0,0,50)
blue = Color.new(0,0,255)
green = Color.new(0,255,0)
----PICTURES-----
whitepic = Image.createEmpty(480,272)
waterimg = Image.createEmpty(480,180)
waterimg:clear(Color.new(255,255,255,60)) 
ashura_walk = Image.load("files/images/ashura_walk.png")
grass = Image.load("files/images/grass.png")
items = Image.load("files/images/items.png")
lvl1bg = Image.load("files/images/lvl1bg.png")
lvl2bg = Image.load("files/images/lvl2bg.png")
lvl3bg = Image.load("files/images/lvl3bg.png")
lvl4bg = Image.load("files/images/lvl4bg.png")
lvl5bg = Image.load("files/images/lvl5bg.png")
titlebg = Image.load("files/images/titlebg.png")
bar = Image.createEmpty(100,5)
bar:clear(Color.new(255,255,0,50))
bluebar = Image.createEmpty(330,272)
bluebar:clear(lightblue)
Music.playFile("files/music/titlesong.it",true)
---SOUNDS----
presong = Sound.load("files/music/presong.wav")
warning = Sound.load("files/music/warning.wav")
sega = Sound.load("files/music/sega.wav")
sega:play()
explode = Sound.load("files/music/explode.wav")
freeman = Sound.load("files/music/freeman.wav")
ringsound = Sound.load("files/music/ringsound.wav")
speedsound = Sound.load("files/music/speedsound.wav")
restartsound = Sound.load("files/music/restartsound.wav")
--rings = Sound.load("files/music/rings.wav")
boing = Sound.load("files/music/boing.wav")
jumpsound = Sound.load("files/music/jump.wav")
---CALL VARIABLES---
	dofile("files/variables.lua")
---CALL FUNCTIONS----
	dofile("files/functions.lua")
---CALL ENEMIES----
	dofile("files/enemies.lua")
-----------MAIN LOOOP-----
while true do 
pad = Controls.read()
screen:clear()
---IN GAME----
if game.state == "ingame" then
	speed_restriction()
	ground_move()
	player_health()
---PLAYER MOVEMENT---
	--if pad:square() then player.health = player.health - 1 end
	--if player.speed == 0 then player.direc = "stopped" end
	--if pad:right() and player.speed == 0 then player.direc = "right" end
	if pad:right() then level.distance = level.distance + 1 player.state = "runing" player.speed = player.speed + .05 ground.mov = ground.mov + .05 elseif pad:left() and ground.mov and player.speed > 0 then player.state = "stopping" player.speed = player.speed - .1 ground.mov = ground.mov - .1 elseif player.speed and ground.mov > 0 then ground.mov = ground.mov -0.05 player.speed = player.speed -0.05  end 
	--if pad:left() and player.speed == 0 then player.direc = "left" end
	--if pad:left() and player.direc == "left" then level.distnace = level.distance - 1 player.state = "runingleft" player.speed = player.speed + .05 elseif pad:right() and player.speed < 0 then player.state = "stopping" player.speed = player.speed + .1 elseif player.speed < 0 then player.speed = player.speed +.05 end
	jump()
	if pad:cross() and not oldpad:cross() and ground.y <= 141 then jumpsound:play() player.jumpspeed = 2.7 end
	if player.speed == 0 and player.state == "runing" then player.state = "standing" end
------LEVELS-----
	if game.level == 1 then
		clear_level()
		level.name = "GREEN HILL"
	screen:blit(bg.x,ground.y-200,lvl1bg)
	screen:blit(bg.x+480,ground.y-200,lvl1bg)
	screen:blit(sign.x,ground.y+5,items,0,0,42,47)
	screen:blit(ground.x,ground.y + player.height,grass,0,0,480,118)
	screen:blit(ground.x +480,ground.y + player.height,grass,0,0,480,118)
	spring_func()
	shoes()
	coinsget()
	blueguyhit()
	crabhit()
	--screen:blit(spikes.x,spikes.y,items,57,63,33,34)
		elseif game.level == 2 then 
		clear_level()
		level.name = "MARBLE ZONE"
	screen:blit(bg.x,ground.y-200,lvl2bg)
	screen:blit(bg.x+480,ground.y-200,lvl2bg)
	screen:blit(sign.x,ground.y+5,items,0,0,42,47)
	screen:blit(ground.x,ground.y + player.height,grass,0,118,480,235)
	screen:blit(ground.x +480,ground.y + player.height,grass,0,118,480,235)
	coinsget()
	shoes()
	tikipolehit()
	lavamov()
		elseif game.level == 3 then
		clear_level()
		level.name = "AQUATIC RUIN"
	screen:blit(bg.x,ground.y-200,lvl3bg)
	screen:blit(bg.x+480,ground.y-200,lvl3bg)
	screen:blit(sign.x,ground.y+5,items,0,0,42,47)
	screen:blit(ground.x,ground.y + player.height,grass,0,235,480,116)
	screen:blit(ground.x +480,ground.y + player.height,grass,0,235,480,116)
	coinsget()
	spring_func()
	shoes()
	watertime()
	crabhit()
		elseif game.level == 4 then
		clear_level()
		level.name = "ICE CAP ZONE"
	screen:blit(bg.x,ground.y-200,lvl4bg)
	screen:blit(bg.x+480,ground.y-200,lvl4bg)
	screen:blit(sign.x,ground.y+5,items,0,0,42,47)
	screen:blit(ground.x,ground.y + player.height,grass,0,352,480,124)
	screen:blit(ground.x +480,ground.y + player.height,grass,0,352,480,124)
	coinsget()	
		elseif game.level == 5 then
		clear_level()
		level.name = "STARLIGHT ZONE"
	screen:blit(bg.x,ground.y-200,lvl5bg)
	screen:blit(bg.x+480,ground.y-200,lvl5bg)
	screen:blit(sign.x,ground.y+5,items,0,58,50,50)
	screen:blit(ground.x,ground.y + player.height,items,0,273,480,114)
	screen:blit(ground.x +480,ground.y + player.height,items,0,273,480,114)
	coinsget()
----LEVELENDS---
		end
	playerwalk()
----CROSSBAR INTRO----
	level.opentimer = level.opentimer +1
	if level.opentimer > 80 then  level.crossx = level.crossx - 1 end
	if level.opentimer > 81 then level.opentimer = 81 end
	if level.crossx < -120 then level.crossx = -120 end
	level.crosstimer = level.crosstimer + 1
	if level.crosstimer > 272 then level.crosstimer = 0 end
	screen:blit(level.crossx,level.crosstimer,items,143,0,120,272)
	screen:blit(level.crossx,level.crosstimer -272,items,143,0,120,272)
	screen:print(level.crossx +20,140,""..level.name,white)
---END INTRO BAR--------
	screen:blit(20,15,items,77,19,66,27)
	screen:print(53,20,""..player.score,white)
	screen:fillRect(53,30,player.health,5,red)
	screen:blit(53,30,bar)
	screen:print(87,20,"lvl "..game.level,white)
	screen:blit(20,250,items,82,3,16,14)
	screen:print(37,249,"ASHURA",yellow)
	screen:print(37,256,"x"..player.lives,white)
	waiting()
	game_over()
	if pad:start() and not oldpad:start() then game.state = "paused" end
-----PAUSED GAME-----
elseif game.state == "paused" then
screen:clear(shadow)
	if pad:down() and not oldpad:down() then pause.selec = pause.selec + 1 
	elseif pad:up() and not oldpad:up() then pause.selec = pause.selec -1 end
	if pause.selec > 2 then pause.selec = 1 elseif pause.selec < 1 then pause.selec = 2 end
	screen:blit(-1,level.crosstimer,items,143,0,120,272)
	screen:blit(-1,level.crosstimer -272,items,143,0,120,272)
	screen:print(20,140,""..level.name,white)
	if pad:right() and pause.selec == 1 then music.vol = music.vol + .5
	elseif pad:left() and pause.selec == 1 then music.vol = music.vol - .5
	elseif pad:cross() and not oldpad:cross() and pause.selec == 2 then game.state = "mainmenu" Music.playFile("files/music/titlesong.it",true) game.level = 1	end
	if music.vol > 128 then music.vol = 128 elseif music.vol < 0 then music.vol = 0 end
	screen:print(200,0,"::PAUSED::",white)
	screen:print(140,100,"<-music-volume->",white)
	screen:print(140,130,"QUIT TO MAIN MENU",white)
	if pause.selec == 1 then screen:print(140,100,"<-music-volume->",red) end
	if pause.selec == 2 then screen:print(140,130,"QUIT TO MAIN MENU",red) end
	screen:fillRect(140,120,128,10,yellow)
	screen:fillRect(140,120,music.vol,10,red)
	Music.volume(music.vol)
	if pad:start() and not oldpad:start() then game.state = "ingame" end
elseif game.state == "mainmenu" then 
	screen:clear()
	level.opentimer = 0
	level.crossx = -1
	screen:blit(0,-1,titlebg)
	screen:print(220,200,"START",white)
	screen:print(228,210,"EXIT",white)
	if pad:cross() and not oldpad:cross() and mainmenu.selec == 1 then Music.stop() presong:play()  game.state = "premenu" screen:clear()
	elseif pad:cross() and not oldpad:cross() and mainmenu.selec == 2 then end
	if pad:down() and not oldpad:down() then mainmenu.selec = mainmenu.selec + 1 
	elseif pad:up() and not oldpad:up() then mainmenu.selec = mainmenu.selec - 1 end
	if mainmenu.selec > 2 then mainmenu.selec = 1 elseif mainmenu.selec < 1 then mainmenu.selec = 2 end
	if mainmenu.selec == 1 then screen:print(220,200,"START",red) end
	if mainmenu.selec == 2 then screen:print(228,210,"EXIT",red) end 																																																																																																				screen:print(0,0,"Demo_Version",white)
elseif game.state == "premenu" then
screen:clear(white)
	if game.pretime > 100 then game.pretime = 0 game.state = "ingame" 
	Music.playFile("files/music/level_1.it",true) level_restart() player.score = 0	end
----FADE IN
screen:blit(0,0,whitepic)
game.pretime = game.pretime + .5
	if game.pretime >= 0 and game.pretime <=10 then
	whitepic:clear(Color.new(0,0,0,200))
	elseif game.pretime >= 10 and game.pretime <=20 then
	whitepic:clear(Color.new(0,0,0,150))
	elseif game.pretime >= 20 and game.pretime <=30 then
	whitepic:clear(Color.new(0,0,0,100))
	elseif game.pretime >= 30 and game.pretime <=40 then
	whitepic:clear(Color.new(0,0,0,50))
	elseif game.pretime >= 40 and game.pretime <=200 then
	screen:print(200,100,"GET READY",red)																																																																																																								screen:print(0,262,"By:waywardson",green)
	screen:blit(player.x,player.y,ashura_walk,0,0,34,52)
	whitepic:clear(Color.new(0,0,0,0))
	 end
--FADE END
elseif game.state == "levelwin" then
	level.fin = 0
	screen:clear()
	playerwalk()
	screen:blit(150,0,bluebar)
	screen:fillRect(0,140,480,30,shadow)
	screen:blit(0,0,items,262,0,119,272)
	screen:print(200,150,"STAGE CLEAR",white)
	screen:print(200,160,"press x to continue",blue)
	if game.level == 1 then screen:print(50,170,"Level2:Marble zone..outrun the lava",red)
	screen:print(50,180,"to stay alive",red)
	end
	if game.level == 2 then screen:print(50,170,"Level3:AQUATIC ruin..use the springs to jump out",red)
	screen:print(50,180,"of the water and regain your air",red)
	end
	if pad:cross() and not oldpad:cross() and game.level == 1 then  
	Music.playFile("files/music/lvl2song.it",true)
	level_restartclear()
	game.state = "ingame"
	game.level = 2
	elseif pad:cross() and not oldpad:cross() and game.level == 2 then 
	level_restartclear()
	crab.x[1] = 1100
	crab.x[2] = 2700
	crab.x[3] = 4500
	crab.x[4] = 5300
	crab.x[5] = 7000
	crab.x[6] = 9300
	game.state = "demoend"
	game.level = 3 
	elseif pad:cross() and not oldpad:cross() and game.level == 3 then
	Music.playFile("files/music/lvl4song.it",true)
	level_restartclear()
	game.state = "ingame"
	game.level = 4
	elseif pad:cross() and not oldpad:cross() and game.level == 4 then
	Music.playFile("files/music/lvl5song.it",true)
	level_restartclear()
	game.state = "ingame"
	game.level = 5
	end
elseif game.state == "gameover" then
	Music.stop()
	screen:print(200,100,"GAME OVER",white)
	screen:print(170,120,"press start for main menu",white)
	if pad:start() and not oldpad:start() then game.state = "mainmenu" Music.playFile("files/music/titlesong.it",true) game.level = 1 end
---STATE ENDS----
elseif game.state == "demoend" then
	screen:print(0,0,"THANKS For Trying The Demo Release",white)
	screen:print(0,10,"Please Leave Feedback",white)
end
screen.waitVblankStart()
oldpad = pad
--if pad:select() then break end
if pad:select() then screen:save("screen.png") end
screen.flip()
end